package com.fr.plugins.dsgroup;

import com.fr.base.TableData;
import com.fr.design.data.datapane.TableDataPaneListPane;
import com.fr.design.data.tabledata.wrapper.TableDataWrapper;
import com.fr.file.DatasourceManager;
import com.fr.file.DatasourceManagerProvider;
import com.fr.file.TableDataConfig;
import com.fr.general.NameObject;
import com.fr.plugins.dsgroup.fun.DSGroupTableData;
import com.fr.stable.Nameable;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * Created by phetran_ye on 2019-03-12.
 */
public class CustomTableDataPaneListPane extends TableDataPaneListPane {
    Map<String,TableData> changedDatas=new HashMap<String, TableData>();
    //为更改名称
    public void rename(String oldName, String newName) {
        super.rename(oldName, newName);
        DatasourceManagerProvider datasourceManager = DatasourceManager.getProviderInstance();
        Iterator iterator=datasourceManager.getTableDataNameIterator();
        boolean isChanged;
        String separator= DSGroupTableData.getSeparator();
        String newNameToReplaceWith=separator+newName+separator;
        String oldNameToMatchWith=separator+oldName+separator;
        while(iterator.hasNext()){
            isChanged=false;
            String name=(String)iterator.next();
            if(datasourceManager.getTableData(name) instanceof DSGroupTableData){
                DSGroupTableData tableData=(DSGroupTableData)datasourceManager.getTableData(name);
                String childNodes=tableData.getChildrenDSNames();

                childNodes=separator+childNodes+separator;

                if(childNodes.indexOf(oldNameToMatchWith)>-1){
                    childNodes=childNodes.replace(oldNameToMatchWith,newNameToReplaceWith).replaceAll("^"+separator+"{1}","").replaceAll(separator+"${1}","");
                    tableData.setChildrenDSNames(childNodes);
                    isChanged=true;
                }
                String parentNode=tableData.getParentDSName();
                if(parentNode.equals(oldName)){
                    parentNode=newName;
                    tableData.setParentDSName(parentNode);
                    isChanged=true;
                }
                if(isChanged){
                    changedDatas.put(name,tableData);
                    //datasourceManager.removeTableData(name);
                    //datasourceManager.putTableData(name, tableData);
                    /*datasourceManager.getTableDataModifyDetails().put(name, tableData);
                    update(datasourceManager);*/
                    //getDsNameChangedMap().put(name,name);
                }

            }
        }

    }

    @Override
    public void update(TableDataConfig dataConfig){
        LinkedHashMap<String,TableData> tableDatas = new LinkedHashMap();
        Nameable[] tableDataArray = this.update();
        for (int i = 0; i < tableDataArray.length; i++) {
            NameObject nameObject = (NameObject) tableDataArray[i];
            if(changedDatas.containsKey(nameObject.getName())){
                tableDatas.put(nameObject.getName(),changedDatas.get(nameObject.getName()));
            }else{
                tableDatas.put(nameObject.getName(), (TableData) nameObject.getObject());
            }

        }
        dataConfig.setTableDatas(tableDatas);
        changedDatas.clear();
    }


    }
