package com.fr.plugins.dsgroup;

import com.fr.design.data.datapane.TableDataTree;
import com.fr.design.gui.itree.refreshabletree.ExpandMutableTreeNode;
import com.fr.design.mainframe.dnd.ArrayTransferable;
import com.fr.general.NameObject;
import com.fr.plugins.dsgroup.fun.DSGroupTableData;

import javax.swing.*;
import javax.swing.tree.TreePath;
import java.awt.*;
import java.awt.dnd.*;
import java.util.*;

/**
 * Created by phetran_ye on 2018/8/20.
 */
public class CustomTableDataTreeDragSource extends DragSourceAdapter implements DragGestureListener {
    private DragSource source;
    private String[][] doubleArray;
    private Point orginPoint;
    private Point orginPointInScreen;
    private CustomTableDataTree tree;

    public CustomTableDataTreeDragSource(JTree tree, int actions) {
        source = new DragSource();
        source.createDefaultDragGestureRecognizer(tree, actions, this);
        if(tree instanceof CustomTableDataTree) this.tree=(CustomTableDataTree)tree;
        /*toolTipPopup.setLayout(new BorderLayout());
        toolTipPopup.setPreferredSize(new Dimension(50,50));
        toolTipPanel.add(toolTipLabel);*/
    }

    TreePath groupToMoveTo;
    /*private JPopupMenu toolTipPopup= new JPopupMenu();
    private JPanel toolTipPanel = new JPanel();
    private JLabel toolTipLabel=new JLabel();*/

    /*
      * Drag Gesture Handler
      */
    public void dragGestureRecognized(DragGestureEvent dge) {
        //
        if(null==orginPoint) orginPoint=dge.getDragOrigin();
        //
        groupToMoveTo =null;
        Component comp = dge.getComponent();
        if (comp instanceof TableDataTree) {

            java.util.List<String[]> stringList = new ArrayList<String[]>();
            TableDataTree tree = (TableDataTree) comp;

            TreePath[] paths = tree.getSelectionPaths();
            if (paths == null) {
                return;
            }
            doubleArray = null;
            setnameArray(paths, stringList);

            source.startDrag(dge, DragSource.DefaultLinkDrop, new ArrayTransferable(doubleArray), this);
        }
    }

    private void setnameArray(TreePath[] paths, java.util.List<String[]> stringList) {
        for (int i = 0; i < paths.length; i++) {
            if ((paths[i] == null) || (paths[i].getPathCount() <= 1)) {
                return;// We can't move the root node or an empty selection
            }
            ExpandMutableTreeNode segmentMutableTreeNode = (ExpandMutableTreeNode) paths[i].getLastPathComponent();
            Object userObj = segmentMutableTreeNode.getUserObject();
            java.util.List<String> tableAddress = new ArrayList<String>();
            String displayName;
            StringBuffer dsNameBuf = new StringBuffer();
            if (userObj instanceof NameObject) {
                continue;
            } else {
                if (!(userObj instanceof String)) {
                    continue;
                }
                displayName = (String) userObj;
                // james 读取表名
                while (segmentMutableTreeNode.getParent().getParent() != null) {
                    segmentMutableTreeNode = (ExpandMutableTreeNode) segmentMutableTreeNode.getParent();
                    if(tree.isGroupData(segmentMutableTreeNode)){
                        continue;
                    }
                    ExpandMutableTreeNode datasheetExpandMutableTreeNode = segmentMutableTreeNode;
                    Object parentUserObj = datasheetExpandMutableTreeNode.getUserObject();
                    if (parentUserObj instanceof NameObject && !(((NameObject) parentUserObj).getObject() instanceof Integer)) {
                        NameObject nameObject = (NameObject) parentUserObj;
                        tableAddress.add(nameObject.getName());
                    }
                }
            }
            for (int j = tableAddress.size() - 1; j > -1; j--) {
                dsNameBuf.append(tableAddress.get(j));
                if (j != 0) {
                    dsNameBuf.append('_');
                }
            }
            String dsName;
            if (dsNameBuf.toString() != null) {
                dsName = dsNameBuf.toString();
            } else {
                return;
            }
            String[] attributes = {dsName, displayName};
            stringList.add(attributes);
            Object[] bo = stringList.toArray();
            doubleArray = new String[bo.length][];
            for (int io = 0; io < bo.length; io++) {
                if (bo[io] instanceof String[]) {
                    doubleArray[io] = (String[]) bo[io];
                }
            }
        }
    }

    @Override
    public void dragOver(DragSourceDragEvent dsde) {
        DragSourceContext dsc = dsde.getDragSourceContext();
        Component comp=dsc.getComponent();
        TableDataTree tree = (TableDataTree) comp;
        Point p=dsde.getLocation();
        if(null==orginPointInScreen) orginPointInScreen=p;
        TreePath path = tree.getPathForLocation((int)(orginPoint.getX()+p.getX()-orginPointInScreen.getX()),
                (int)(orginPoint.getY()+p.getY()-orginPointInScreen.getY())) ;
        if(null==path){
            if(null!= groupToMoveTo){
                tree.removeSelectionPath(groupToMoveTo);
                groupToMoveTo=null;
            }
        }else{
            //移入选择的分组是之前选中的节点之一不做任何处理
            TreePath[] paths=tree.getSelectionPaths();
            for(int i=0;i<paths.length;i++){
                if(paths[i].equals(path)) return;
            }
            if(
                    ((CustomTableDataTree) tree).isGroupData((ExpandMutableTreeNode) path.getLastPathComponent())
                    ){

                if(null==groupToMoveTo){
                    tree.addSelectionPath(path);
                    groupToMoveTo =path;
                }else if(!groupToMoveTo.equals(path)){
                    tree.addSelectionPath(path);
                    tree.removeSelectionPath(groupToMoveTo);
                    groupToMoveTo =path;
                }

            }else{
                if(null!= groupToMoveTo){
                    tree.removeSelectionPath(groupToMoveTo);
                    groupToMoveTo=null;
                }
            }

            //显示tooltip
            //showTooltip("hello",p,pane);
           /* ToolTipManager.sharedInstance().registerComponent(tree);
            tree.setToolTipText("haha");
            Object o=tree.getActionMap();
            Action action = tree.getActionMap().get("postTip");
            *//*if (action == null) // no tooltip
                return;*//*
            ActionEvent ae = new ActionEvent(tree, ActionEvent.ACTION_PERFORMED,
                    "postTip", EventQueue.getMostRecentEventTime(), 0);
            action.actionPerformed(ae);*/
            /*JToolTip toolTip=pane.createToolTip();
            toolTip.setLocation(p);
            toolTip.setVisible(true);
            toolTip.setTipText("haha");*/

        }




    }

    @Override
    public void dragDropEnd(DragSourceDropEvent dsde) {
        DragSourceContext dsc = dsde.getDragSourceContext();
        Component comp=dsc.getComponent();
        CustomTableDataTree tree = (CustomTableDataTree) comp;
        Point p=dsde.getLocation();
        if(null==orginPoint||null==orginPointInScreen) return;
        TreePath path = tree.getPathForLocation((int)(orginPoint.getX()+p.getX()-orginPointInScreen.getX()),
                (int)(orginPoint.getY()+p.getY()-orginPointInScreen.getY())) ;
        //没选中意味移到根路径下
        if(null==path) {
            tree.moveToRoot();
        }
        //移入的分组如果是选中的节点之一，不做处理,移入后该分组自动选择这里不判断了
        /*TreePath[] paths=tree.getSelectionPaths();
        for(int i=0;i<paths.length;i++){
            if(paths[i].equals(path)) return;
        }*/
        //将数据集或者分组移动到该分组下
        if(null!= groupToMoveTo && groupToMoveTo.equals(path)){
            tree.moveToGroup((ExpandMutableTreeNode) groupToMoveTo.getLastPathComponent());
        }
        orginPoint=null;
        orginPointInScreen=null;
        groupToMoveTo =null;
    }

    /*private void moveToGroup(CustomTableDataTree tree,TreePath group){
        String children=tree.getGroupData((ExpandMutableTreeNode) groupToMoveTo.getLastPathComponent()).getChildrenDSNames();
        TreePath[] paths=tree.getSelectionPaths();

        String chosenChildren=DSGroupTableData.getSeparator();
        for(int i=0;i<paths.length;i++){
            //待分组的节点是分组
            if(tree.isGroupData((ExpandMutableTreeNode) paths[i].getLastPathComponent())){
                chosenChildren+=DSGroupTableData.getSeparator()+tree.getGroupData((ExpandMutableTreeNode) paths[i].getLastPathComponent()).getChildrenDSNames();
            }
        }
        chosenChildren+=DSGroupTableData.getSeparator();
        for(int i=0;i<paths.length;i++){
            //?if(path.equals(paths[i])) continue;
            //待分组的节点是分组
            if(tree.isGroupData((ExpandMutableTreeNode) paths[i].getLastPathComponent())){
                tree.getGroupData((ExpandMutableTreeNode)paths[i].getLastPathComponent()).setParentDSName(
                        tree.getDSName((ExpandMutableTreeNode) groupToMoveTo.getLastPathComponent())
                );

            }
            //选中的节点是该分组下的节点
            if(chosenChildren.indexOf(
                    DSGroupTableData.getSeparator()+
                            tree.getDSName((ExpandMutableTreeNode) paths[i].getLastPathComponent())+
                            DSGroupTableData.getSeparator()
            )>0
                    ) continue;
            children+= DSGroupTableData.getSeparator()+tree.getDSName((ExpandMutableTreeNode) paths[i].getLastPathComponent());
        }
        tree.getGroupData((ExpandMutableTreeNode) groupToMoveTo.getLastPathComponent()).setChildrenDSNames(children);
        pane.getTC().fireTargetModified();
        tree.refreshChildByName(tree.getDSName((ExpandMutableTreeNode) groupToMoveTo.getLastPathComponent()));
    }*/
    //提示信息
    /*private void showTooltip(String text,Point p,Component comp){
        toolTipLabel.setText(text);
        toolTipPopup.show(comp, (int) p.getX(), (int) p.getX());

    }*/


}
