package com.fr.plugins.dsgroup;

/**
 * Created by phetran_ye on 2018/8/8.
 */
import com.fr.base.BaseUtils;
import com.fr.base.TableData;
import com.fr.base.io.BaseBook;
import com.fr.data.TableDataSource;
import com.fr.data.impl.TableDataSourceDependent;
import com.fr.design.DesignModelAdapter;
import com.fr.design.ExtraDesignClassManager;
import com.fr.design.actions.UpdateAction;
import com.fr.design.constants.UIConstants;
import com.fr.design.data.BasicTableDataTreePane;
import com.fr.design.data.BasicTableDataUtils;
import com.fr.design.data.DesignTableDataManager;
import com.fr.design.data.datapane.TableDataSourceOP;
import com.fr.design.data.datapane.TableDataTree;
import com.fr.design.data.datapane.TableDataTreePane;
import com.fr.design.data.tabledata.StoreProcedureWorkerListener;
import com.fr.design.data.tabledata.tabledatapane.AbstractTableDataPane;
import com.fr.design.data.tabledata.wrapper.AbstractTableDataWrapper;
import com.fr.design.dialog.BasicDialog;
import com.fr.design.dialog.BasicPane;
import com.fr.design.dialog.DialogActionAdapter;
import com.fr.design.file.HistoryTemplateListCache;
import com.fr.design.fun.TableDataPaneProcessor;
import com.fr.design.gui.ibutton.UIHeadGroup;
import com.fr.design.gui.icontainer.UIResizableContainer;
import com.fr.design.gui.icontainer.UIScrollPane;
import com.fr.design.gui.itextfield.UITextField;
import com.fr.design.gui.itoolbar.UIToolbar;
import com.fr.design.gui.itree.refreshabletree.ExpandMutableTreeNode;
import com.fr.design.i18n.Toolkit;
import com.fr.design.icon.IconPathConstants;
import com.fr.design.layout.FRGUIPaneFactory;
import com.fr.design.mainframe.DesignerContext;
import com.fr.design.mainframe.JTemplate;
import com.fr.design.mainframe.WestRegionContainerPane;
import com.fr.design.mainframe.chart.gui.data.TableDataPane;
import com.fr.design.menu.MenuDef;
import com.fr.design.menu.SeparatorDef;
import com.fr.design.menu.ToolBarDef;
import com.fr.general.ComparatorUtils;
import com.fr.general.GeneralContext;
import com.fr.general.Inter;
import com.fr.general.NameObject;
import com.fr.plugin.context.PluginContext;
import com.fr.plugin.injectable.PluginModule;
import com.fr.plugin.manage.PluginFilter;
import com.fr.plugin.observer.PluginEvent;
import com.fr.plugin.observer.PluginEventListener;
import com.fr.plugins.dsgroup.fun.DSGroupTableData;
import com.fr.stable.core.PropertyChangeAdapter;

import javax.swing.*;
import java.awt.*;
import java.awt.dnd.DnDConstants;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class CustomTableDataTreePane extends BasicTableDataTreePane {

    public static final int PLUGIN_LISTENER_PRIORITY = 1;
    private TableDataSourceOP op;
    private CustomTableDataTree dataTree;
    private EditAction editAction;
    private RemoveAction removeAction;
    private PreviewTableDataAction previewTableDataAction;
    private static CustomTableDataTreePane singleton = new CustomTableDataTreePane();
    //前一个默认pane
    private static TableDataTreePane exPane;
    //前一个自定义pane
    private static CustomTableDataTreePane exCustomPane;



    public synchronized static BasicTableDataTreePane getInstance(DesignModelAdapter<?, ?> tc) {

        if (singleton.tc == null) {
            singleton.addMenuDef.clearShortCuts();
            singleton.createAddMenuDef();
        }

        singleton.tc = tc;
        singleton.op = new TableDataSourceOP(tc);
        singleton.op.setDataMode(singleton.buttonGroup.getSelectedIndex() == 0 ? TEMPLATE_TABLE_DATA : SERVER_TABLE_DATA);
        singleton.refreshDockingView();

        WestRegionContainerPane wp=WestRegionContainerPane.getInstance();
        JComponent downPane=wp.getDownPane();
        if(downPane!=singleton) {
            wp.replaceDownPane(singleton);
        }
        return singleton;
    }



    private CustomTableDataTreePane() {
        this.setLayout(new BorderLayout(4, 0));
        this.setBorder(null);
        dataTree = new CustomTableDataTree();
        ToolTipManager.sharedInstance().registerComponent(dataTree);
        ToolTipManager.sharedInstance().setDismissDelay(3000);
        ToolTipManager.sharedInstance().setInitialDelay(0);
        addMenuDef = new MenuDef(Toolkit.i18nText("Fine-Design_Basic_Action_Add"));
        addMenuDef.setIconPath(IconPathConstants.ADD_POPMENU_ICON_PATH);
        createAddMenuDef();
        GeneralContext.listenPluginRunningChanged(new PluginEventListener(PLUGIN_LISTENER_PRIORITY) {

            @Override
            public void on(PluginEvent event) {
                WestRegionContainerPane wp=WestRegionContainerPane.getInstance();
                JComponent downPane=wp.getDownPane();
                BasicTableDataTreePane pane=TableDataTreePane.getInstance(DesignModelAdapter.getCurrentModelAdapter());
                if(downPane!=pane) {
                    wp.replaceDownPane(pane);
                }
                addMenuDef.clearShortCuts();
                createAddMenuDef();
            }
        }, new PluginFilter() {

            @Override
            public boolean accept(PluginContext context) {

                return context.contain(PluginModule.ExtraDesign);
            }
        });
        GeneralContext.listenPluginRunningChanged(new PluginEventListener() {
            public void on(PluginEvent event){
                this.reloadCurrTemplate();
            }
            private void reloadCurrTemplate() {
                JTemplate temp = HistoryTemplateListCache.getInstance().getCurrentEditingTemplate();
                if (this.accept(temp)) {
                    temp.refreshResource();
                }

            }

            private boolean accept(JTemplate<?, ?> temp) {
                return temp != null && temp.getEditingFILE() != null && temp.getEditingFILE().exists();
            }
        }, new PluginFilter() {
            public boolean accept(PluginContext cxt) {
                return cxt.contain("TableDataDefineProvider");
            }
        });

        editAction = new EditAction();
        removeAction = new RemoveAction();
        previewTableDataAction = new PreviewTableDataAction(dataTree);
        connectionTableAction = new ConnectionTableAction();
        ToolBarDef toolbarDef = new ToolBarDef();
        toolbarDef.addShortCut(addMenuDef,SeparatorDef.DEFAULT, editAction, removeAction, SeparatorDef.DEFAULT, previewTableDataAction, connectionTableAction);
        UIToolbar toolBar = ToolBarDef.createJToolBar();
        toolBar.setBorder(BorderFactory.createMatteBorder(0, 0, 1, 0, UIConstants.TOOLBAR_BORDER_COLOR));
        toolBar.setBorderPainted(true);
        toolbarDef.updateToolBar(toolBar);

        JPanel toolbarPane = FRGUIPaneFactory.createBorderLayout_S_Pane();
        toolbarPane.add(toolBar, BorderLayout.CENTER);
        this.add(toolbarPane, BorderLayout.NORTH);

        UIScrollPane scrollPane = new UIScrollPane(dataTree);
        scrollPane.setBorder(null);
        initbuttonGroup();
        JPanel jPanel = new JPanel(new BorderLayout(0, 0));
        JPanel buttonPane = new JPanel(new GridLayout());
        buttonPane.add(buttonGroup, BorderLayout.CENTER);
        jPanel.add(buttonPane, BorderLayout.NORTH);
        jPanel.add(scrollPane, BorderLayout.CENTER);
        this.add(jPanel, BorderLayout.CENTER);
        dataTree.addMouseListener(new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent e) {
                checkButtonEnabled();
            }
        });
        dataTree.addKeyListener(getTableTreeNodeListener(editAction, previewTableDataAction, removeAction, op, dataTree));
        // TreeCellEditor
        dataTree.setEditable(true);
        TableDataTreeCellEditor treeCellEditor = new TableDataTreeCellEditor(new UITextField(), dataTree, this);
        treeCellEditor.addCellEditorListener(treeCellEditor);
        dataTree.setCellEditor(treeCellEditor);
        dataTree.setPane(this);
        new CustomTableDataTreeDragSource(dataTree, DnDConstants.ACTION_COPY);
        checkButtonEnabled();


    }

    protected DesignModelAdapter getTC(){
        return tc;
    }

    protected void checkButtonEnabled() {
        super.checkButtonEnabled(editAction, previewTableDataAction, removeAction, op, dataTree);
        //新版本去掉
        /*int selectioncount = dataTree.getSelectionCount();
        if (selectioncount == 1 && dataTree.isGroupData((ExpandMutableTreeNode) dataTree.getSelectionPath().getLastPathComponent())) {
            previewTableDataAction.setEnabled(false);
        }*/
    }

    /**
     * 刷新
     */
    public void refreshDockingView() {
        populate(new TableDataSourceOP(tc));
        this.checkButtonEnabled();
    }

    protected void initbuttonGroup() {
//        Icon[] iconArray = {BaseUtils.readIcon("/com/fr/design/images/data/datasource.png"), BaseUtils.readIcon("/com/fr/design/images/data/dock/serverdatabase.png")};
        final Integer[] modeArray = {TEMPLATE_TABLE_DATA, SERVER_TABLE_DATA};
        String[] textArray = new String[]{Toolkit.i18nText("Fine-Design_Basic_Tabledata_Source_Type_Template"), Toolkit.i18nText("Fine-Design_Basic_DS_Server_TableData")};
        buttonGroup = new UIHeadGroup(textArray) {
            public void tabChanged(int index) {
                if (op != null) {
                    op.setDataMode(modeArray[buttonGroup.getSelectedIndex()]);
                    addMenuDef.setEnabled(modeArray[buttonGroup.getSelectedIndex()] == TEMPLATE_TABLE_DATA ? true : false);
                    refreshDockingView();
                }
            }
        };
        buttonGroup.setNeedLeftRightOutLine(false);
    }

    /**
     * 编辑面板
     *
     * @param uPanel       面板
     * @param originalName 原始名字
     */
    public void dgEdit(final AbstractTableDataPane<?> uPanel, String originalName,final boolean isUpdate) {
        uPanel.addStoreProcedureWorkerListener(new StoreProcedureWorkerListener() {
            public void fireDoneAction() {
                if (dataTree.getSelectionPath() == null) {
                    dataTree.refresh();
                } else {
                    Object object = dataTree.getSelectionPath().getLastPathComponent();
                    int[] rows = dataTree.getSelectionRows();
                    dataTree.refreshChildByName(object.toString());
                    dataTree.setSelectionRows(rows);
                }
            }
        });
        final NamePane nPanel = uPanel.asNamePane();
        nPanel.setObjectName(originalName);
        final String oldName = originalName;
        final BasicDialog dg;
        allDSNames = DesignTableDataManager.getAllDSNames(tc.getBook());
        dg = nPanel.showLargeWindow(SwingUtilities.getWindowAncestor(CustomTableDataTreePane.this), new DialogActionAdapter() {
            public void doOk() {
                DesignTableDataManager.setThreadLocal(DesignTableDataManager.NO_PARAMETER);
                tc.renameTableData(oldName, nPanel.getObjectName(), false);
                TableDataSource tds = tc.getBook();
                TableData td = uPanel.updateBean();

                if (td instanceof TableDataSourceDependent) {
                    ((TableDataSourceDependent) td).setTableDataSource(tds);
                }
                String tdName = nPanel.getObjectName();
                tds.putTableData(tdName, td);
                Map<String, String> map = new HashMap<String, String>();
                if (!ComparatorUtils.equals(oldName, tdName)) {
                    map.put(oldName, tdName);
                }
                fireDSChanged(map);
                tc.fireTargetModified();
                tc.parameterChanged();

                int[] rows = dataTree.getSelectionRows();
                //选择了一个数据集后新增分组   如果当前选择的节点是分组&&(!(td instanceof DSGroupTableData))
                if(isUpdate) {
                    //更新数据集
                    dataTree.updateNodeName(oldName,tdName);
                    dataTree.refreshChildByName(tdName);
                }else{
                    //新增数据集
                    if(dataTree.getSelectionPaths()!=null&&dataTree.getSelectionPaths().length==1){//在分组下新增分组
                        ExpandMutableTreeNode tn=(ExpandMutableTreeNode)dataTree.getSelectionPaths()[0].getLastPathComponent();
                        if(dataTree.isGroupData(tn)){//在分组下新增分组
                            String children=dataTree.getGroupData(tn).getChildrenDSNames();
                            children+=((children==null||children.equals(""))?"":DSGroupTableData.getSeparator())+tdName;
                            dataTree.getGroupData(tn).setChildrenDSNames(children);
                            dataTree.refreshChildByName(dataTree.getDSName(tn));//待研究区别
                            //tn.expandCurrentTreeNode(dataTree);待研究怎么展开
                            if(td instanceof DSGroupTableData){//修改当前分组的父分组
                                ((DSGroupTableData) td).setParentDSName(dataTree.getDSName(tn));
                            }
                        }else{
                            dataTree.refreshChildByName(tdName);
                        }
                    }else{
                        dataTree.refreshChildByName(tdName);
                    }
                }

                dataTree.setSelectionRows(rows);
            }
        });
        nPanel.addPropertyChangeListener(new PropertyChangeAdapter() {
            @Override
            public void propertyChange() {
                doPropertyChange(dg, nPanel, oldName);
            }
        });
        dg.setVisible(true);
    }

    private class EditAction extends UpdateAction {
        public EditAction() {
            this.setName(Toolkit.i18nText("Fine-Design_Basic_Edit"));
            this.setMnemonic('E');
            this.setSmallIcon(BaseUtils.readIcon(IconPathConstants.TD_EDIT_ICON_PATH));
        }

        public void actionPerformed(ActionEvent e) {
            final NameObject selectedNO = dataTree.getRealSelectedNameObject();
            if (selectedNO != null) {
                DesignTableDataManager.removeSelectedColumnNames(selectedNO.getName());
                dgEdit(((AbstractTableDataWrapper) selectedNO.getObject()).creatTableDataPane(), selectedNO.getName(), true);
            }

        }
    }

    private class RemoveAction extends UpdateAction {

        public RemoveAction() {
            this.setName(Toolkit.i18nText("Fine-Design_Basic_Remove"));
            this.setMnemonic('R');
            this.setSmallIcon(BaseUtils.readIcon(IconPathConstants.TD_REMOVE_ICON_PATH));
        }

        @Override
        public void actionPerformed(ActionEvent e) {
            NameObject selectedNO = dataTree.getRealSelectedNameObject();

            if (selectedNO == null) {
                return;
            }

            int returnVal = JOptionPane.showConfirmDialog(DesignerContext.getDesignerFrame(), Toolkit.i18nText("Fine-Design_Basic_Utils_Are_You_Sure_To_Remove_The_Selected_Item") + ":" + selectedNO.getName() + "?",
                    Inter.getLocText("FR-Designer_Remove"), JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
            if (returnVal == JOptionPane.OK_OPTION) {
                op.removeAction(selectedNO.getName());
                dataTree.deleteNodeToMoveFromParent((ExpandMutableTreeNode) dataTree.getLastSelectedPathComponent());
                dataTree.refresh();
                dataTree.requestFocus();
                dataTree.setSelectionRow(dataTree.getRowCount() - 1);
                fireDSChanged();
                checkButtonEnabled();
                DesignTableDataManager.removeSelectedColumnNames(selectedNO.getName());
            }
        }
    }

    private void populate(TableDataSourceOP op) {
        this.op = op;
        dataTree.populate(op,null);
        checkButtonEnabled();
    }

    public TableDataSourceOP getOp(){
        return op;
    }

    /**
     * @return
     */
    public TableDataTree getDataTree() {
        return dataTree;
    }

    /**
     * 合并数据集
     * @param srcName 数据集来源(比如报表块，就是报表块的名称)
     * @param tableDataSource 数据集
     */
    public Map<String, String> addTableData(String srcName, TableDataSource tableDataSource,boolean var) {
        Map<String, String> tdNameMap = new HashMap<String,String>();
        allDSNames = DesignTableDataManager.getAllDSNames(tc.getBook());
        DesignTableDataManager.setThreadLocal(DesignTableDataManager.NO_PARAMETER);
        TableDataSource tds = tc.getBook();
        Iterator tdIterator = tableDataSource.getTableDataNameIterator();
        while (tdIterator.hasNext()) {
            String tdName = (String) tdIterator.next();
            String oldName = tdName;
            TableData td = tableDataSource.getTableData(tdName);
            boolean var1 = this.isDsNameRepeaded(tdName);
            tdName= BasicTableDataUtils.getTableDataName(var,tds,tdName,srcName,var1);
            tds.putTableData(tdName, td);
            if (!ComparatorUtils.equals(oldName, tdName)) {
                tdNameMap.put(oldName, tdName);
            }
        }
        tc.parameterChanged();
        dataTree.refresh();
        return  Collections.unmodifiableMap(tdNameMap);
    }

    @Override
    public void addDataPane(AbstractTableDataPane<?> abstractTableDataPane, String s) {
        NamePane namePane=abstractTableDataPane.asNamePane();
        namePane.setObjectName(s);
        this.allDSNames = DesignTableDataManager.getAllDSNames(this.tc.getBook());
        DesignTableDataManager.setThreadLocal(DesignTableDataManager.NO_PARAMETER);
        this.tc.renameTableData(s, namePane.getObjectName(), false);
        BaseBook book = this.tc.getBook();
        TableData td = (TableData)abstractTableDataPane.updateBean();
        if (td instanceof TableDataSourceDependent) {
            ((TableDataSourceDependent)td).setTableDataSource(book);
        }

        String oName = namePane.getObjectName();
        book.putTableData(oName, td);
        HashMap tdMap = new HashMap();
        if (!ComparatorUtils.equals(s, oName)) {
            tdMap.put(s, oName);
        }

        this.fireDSChanged(tdMap);
        this.tc.fireTargetModified();
        this.tc.parameterChanged();
        int[] rows = this.dataTree.getSelectionRows();
        this.dataTree.refreshChildByName(oName);
        this.dataTree.setSelectionRows(rows);

    }

    public void removeTableData(String tdName) {
        BaseBook book = this.tc.getBook();
        book.removeTableData(tdName);
        this.dataTree.refresh();
    }

}
