package com.fr.plugins.dsgroup.fun;


import com.fr.config.holder.Conf;
import com.fr.config.holder.impl.SimConf;
import com.fr.data.AbstractParameterTableData;
import com.fr.design.mainframe.WestRegionContainerPane;
import com.fr.general.data.DataModel;
import com.fr.script.Calculator;
import com.fr.stable.StringUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

/**
 * Created by richie on 2016/10/8.
 */
public class DSGroupTableData extends AbstractParameterTableData {

    private static final String XML_ATTR_TAG = "QueryTableDataAttr";

    private static String separator="&;";
    private Conf<String> attrParentDSName=new SimConf<String>("");
    private Conf<String> attrChildrenDSNames=new SimConf<String>("");

    public Conf<String> getAttrParentDSName() {
        return attrParentDSName;
    }

    public void setAttrParentDSName(Conf<String> attrParentDSName) {
        this.attrParentDSName = attrParentDSName;
    }

    public Conf<String> getAttrChildrenDSNames() {
        return attrChildrenDSNames;
    }

    public void setAttrChildrenDSNames(Conf<String> attrChildrenDSNames) {
        this.attrChildrenDSNames = attrChildrenDSNames;
    }

    public static String getSeparator() {
        return separator;
    }

    public String getChildrenDSNames() {
        return attrChildrenDSNames.get();
    }

    public void setChildrenDSNames(String childrenDSNames) {
        this.attrChildrenDSNames = new SimConf<String>(childrenDSNames);
    }

    public String getParentDSName() {
        return attrParentDSName.get();
    }

    public void setParentDSName(String parentDSName) {
        this.attrParentDSName = new SimConf<String>(parentDSName);
    }



    /*public DSGroupTableData() {
        processParameters();
    }*/


    @Override
    public DataModel createDataModel(Calculator calculator) {
        //return new QueryDataModel(processParameters(calculator));
        return null;
    }

   /* @Override
    public ParameterProvider[] getParameters(Calculator c) {
        processParameters();
        return super.getParameters(c);
    }

    private void processParameters() {
        if (this.parameters == null && StringUtils.isNotEmpty(text)) {
            this.parameters = ParameterHelper.analyze4Parameters(text, false);
        }
    }*/

    /*@Override
    protected ParameterProvider[] processParameters(Calculator calculator) {
        processParameters();
        return Calculator.processParameters(calculator, this.parameters);
    }*/


    @Override
    public void readXML(XMLableReader reader) {
        super.readXML(reader);
        if (reader.isChildNode()) {
            String tagName = reader.getTagName();
            if (tagName.equals(XML_ATTR_TAG)) {
                attrParentDSName = new SimConf<String>(reader.getAttrAsString("parent_DS_name", StringUtils.EMPTY));
                attrChildrenDSNames = new SimConf<String>(reader.getAttrAsString("children_DS_names", StringUtils.EMPTY));
            }
        }
    }

    @Override
    public void writeXML(XMLPrintWriter writer) {
        super.writeXML(writer);
        writer.startTAG(XML_ATTR_TAG);
        writer.attr("parent_DS_name", attrParentDSName.get());
        writer.attr("children_DS_names", attrChildrenDSNames.get());
        writer.end();
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        DSGroupTableData cloned = (DSGroupTableData)super.clone();
        cloned.setAttrParentDSName(attrParentDSName);
        cloned.setAttrChildrenDSNames(attrChildrenDSNames);
        return cloned;
    }
}
